-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

newBirthDescriptor{
	type = "class",
	name = "AEtherOperator",
	desc = {
		"AEtherOperators can work with remains of Global AEther Network. ",
		"#GOLD#Stat modifiers:",
		"#GOLD#Life per level:#LIGHT_BLUE# 10",
		"#GOLD#Experience penalty:#LIGHT_BLUE# 33%",
		"#GOLD#Global Speed:#LIGHT_BLUE# 125%",
		"#GOLD#Spell/Mind Speed:#LIGHT_BLUE# 125%",
	},
	descriptor_choices =
	{
		subclass =
		{
			__ALL__ = "disallow",
			TechPaladin = "allow",
		},
	},
	copy = {
		life_rating = 10,
		life_regen = 1,
		unused_generics = 6,
		combat_mindspeed = 1.25,
		combat_spellspeed = 1.25,
		global_speed_base = 1.25,
	},
    experience = 1.33,
}

newBirthDescriptor{
	type = "subclass",
	name = "TechPaladin",
	desc = {
		"AEtherOperator that using Celestial battlemagic becouse it have most tighter binding to AEther.",
		"#GOLD#Stat modifiers:",
		"#LIGHT_BLUE# * +5 Strength, +5 Constitution, -5 Dexterity",
		"#LIGHT_BLUE# * +5 Magic, -5 Willpower, -5 Cunning",
        "#LIGHT_BLUE# * Luck = 5",
		"#GOLD#Celestial (Sun only) and shield talents",
		"#GOLD#Power source - Arcane"
	},
	inc_stats = { str=5, con=5, cun=-5, wil=-5, mag=5, dex=-5, lck=5 },
    power_source = {arcane=true},
	talents_types = {
		["cunning/TechPaladin"]={true, 0},
        ["technique/combat-training"]={true, 0.0},
        ["technique/conditioning"]={true, 0.0},
        
        ["celestial/guardian"]={true, 0.0},
        ["celestial/combat"]={true, 0.0},
        ["celestial/radiance"]={true, 0.0},
        
        ["celestial/sun"]={true, 0.0},
        ["celestial/sunlight"]={true, 0.0},
        
        ["celestial/chants"]={true, 0.0},
        ["celestial/light"]={true, 0.0},
        
        ["technique/shield-defense"]={true, 0.0}, 
        
	},

	copy = {
		resolvers.equip{ id=true,
			{type="weapon", subtype="greatsword", name="iron greatsword", autoreq=true, ego_chance=1000, ego_chance=1000},
			{type="armor", subtype="light", name="rought leather armour", autoreq=true, ego_chance=1000, ego_chance=1000},
		},
	},
}

-- Allow it in Maj'Eyal campaign
getBirthDescriptor("world", "Maj'Eyal").descriptor_choices.class.AEtherOperator = "allow"
