newTalentType{ allow_random=true, type="cunning/TechPaladin", name = "TechPaladin", description = "TechPaladin skills" }

tourists_req1 = {
	level = function(level) return 0 + (level-1)  end,
}
tourists_req2 = {
	level = function(level) return 4 + (level-1)  end,
}
tourists_req3 = {
	level = function(level) return 8 + (level-1)  end,
}
tourists_req4 = {
	level = function(level) return 12 + (level-1)  end,
}

newTalent{
	name = "Download area map",
	type = {"cunning/TechPaladin", 1},
	points = 1,
	stamina = 100,
	cooldown = 99,
	range = 100,
	radius = function(self, t) return math.ceil(3 + self:getTalentLevel(t)) end,
	requires_target = true,
	no_npc_use = true,
	action = function(self, t)       
		self:magicMap(999, 0, 0)
		game:playSoundNear(self, "talents/spell_generic2")
		return true
	end,
	info = function(self, t)
		local radius = self:getTalentRadius(t)
		return ([[Download map of entire area from AEther]])
	end,
}

newTalent{
	name = "Deep Scan",
	type = {"cunning/TechPaladin", 2},
    require = tourists_req3,
	points = 1,
	stamina = 100,
	cooldown = 99,
    
	range = 100,
    
	radius = function(self, t) 
        return math.ceil(3 + self:getTalentLevel(t)) 
    end,
    
	action = function(self, t)
        local tg = {type="bolt", range=self:getTalentRange(t), talent=t}
        local x, y, target = self:getTarget(tg)
        if not x or not y then return nil end
        --self:project(tg, x, y, DamageType.FIRE, 10000, nil)
        --self.life = self.max_life
        --game.logSeen(self, "%s attack %s.", self.name:capitalize(), target.name)
        --[[for t_id, t_level in pairs(target.talents) do
            game.logSeen(self, "%s %s.", t_id, t_level)
        end]]
        
        -- specific talents we shouldn't learn
        local talents_to_exclude = {
            -- "T_TELEKINETIC_GRASP", -- requires Beyond the Flesh
            -- these sneak in for some reason even though they're innate...
            "T_SHOOT",
            "T_RELOAD",
            "T_EMPTY_HAND",
            -- these are enemy-only
            "T_SUMMON",
            "T_SHRIEK",
            "T_HOWL",
            "T_MULTIPLY",
            "T_SHADOW_PHASE_DOOR",
            "T_SHADOW_BLINDSIDE",
            "T_DREDGE_FRENZY",
            -- can't be frenzied
            "T_FRENZIED_LEAP",
            "T_FRENZIED_BITE",
        }
        
        for id, talent in pairs(target.talents_def) do
            if talent.innate == true
            --or talent.hide == "always"
            --or talent.type[1]:find("^base/")
            or talent.type[1]:find("^inscriptions/")
            --or talent.type[1]:find("^uber/")
            --or talent.type[1]:find("^race/")
            --or talent.type[1]:find("keepsake")
            or talent.type[1]:find("objects")
            or talent.type[1]:find("golemancy")
            or talent.type[1]:find("golem/golem") 
            then
                table.insert(talents_to_exclude, id)
            end
        end
        
        local contains = function(t, value)
            for k,v in pairs(t) do
                if v==value then return v end
            end
            return nil
        end
        
        local t_ids = {}
        local something_learned = false
        -- make a table of the IDs of all the creature's learnable talents
        for t_id, t_level in pairs(target.talents) do
            if not contains(talents_to_exclude, t_id) then
                local t = self:getTalentFromId(t_id)

                if self:getTalentLevel(t) >= target:getTalentLevel(t) then
                    game.logSeen(self, ("%s ( %s - %s) lv %d already known."):format(t.name, t_id, t.type[1], t_level))
                else
                    local t = self:getTalentFromId(t_id)
                    self:learnTalent(t_id, true)
                    game.logSeen(self, ("%s ( %s - %s) lv %d learned."):format(t.name, t_id, t.type[1], t_level))
                    something_learned = true
 
                --[[ perhaps for a future update
                -- learn talent type at 1.00 mastery if we don't know it
                local tt = t.type[1]
                if not self:knowTalentType(tt) then
                    local tt_def = self:getTalentTypeFrom(tt)
                    local cat = tt_def.type:gsub("/.*", "")
                    self:learnTalentType(tt, false)
                    self:setTalentTypeMastery(tt, 1.00)
                    game.logSeen(self, ("%s learned talent category %s!"):format(self.name, cat:capitalize().." / "..tt_def.name:capitalize()))
                else -- we already know the talent type; add 0.02 mastery
                    mastery_add = 0.02
                    self:setTalentTypeMastery(tt, self:getTalentTypeMastery(tt) + mastery_add)
                    game.logSeen(self, ("%s gained %.2f mastery in talent category %s!"):format(self.name, mastery_add, cat:capitalize().." / "..tt_def.name:capitalize()))
                end
                --]]
                    
                end
            end
        end
        return something_learned
	end,

	info = function(self, t)
		local radius = self:getTalentRadius(t)
		return ([[Scan target and copy talents that you don't possess now.]])
	end,
}

newTalent{
	name = "Overclock",
	type = {"cunning/TechPaladin", 3},
	require = tourists_req3,
	points = 5,
	stamina = 20,
	cooldown = 30,
	action = function(self, t)
		self:setEffect(self.EFF_TOURIST_FURY, math.ceil(5 + self:getTalentLevel(t)), {})
		game:playSoundNear(self, "talents/spell_generic2")
		return true
	end,
	info = function(self, t)
		return ([[Multiply all damage done by 500%% for %d turns.]]):
		format(math.ceil(5 + self:getTalentLevel(t)))
	end,
}

newTalent{
	name = "Firewall",
	type = {"cunning/TechPaladin", 4},
	require = tourists_req4,
	points = 5,
	stamina = 20,
	cooldown = 30,
	action = function(self, t)
		self:setEffect(self.EFF_DIPLOMATIC_IMMUNITY, math.ceil(5 + self:getTalentLevel(t)), {})
		game:playSoundNear(self, "talents/spell_generic2")
		return true
	end,
	info = function(self, t)
		return ([[Become immune to all damage for %d turns.]]):
		format(math.ceil(5 + self:getTalentLevel(t)))
	end,
}
